hdu 3033 I love sneakers! (分组背包)

I love sneakers!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4460    Accepted Submission(s): 1821


Problem Description
After months of hard working, Iserlohn finally wins awesome amount of scholarship. As a great zealot of sneakers, he decides to spend all his money on them in a sneaker store.

There are several brands of sneakers that Iserlohn wants to collect, such as Air Jordan and Nike Pro. And each brand has released various products. For the reason that Iserlohn is definitely a sneaker-mania, he desires to buy at least one product for each brand.
Although the fixed price of each product has been labeled, Iserlohn sets values for each of them based on his own tendency. With handsome but limited money, he wants to maximize the total value of the shoes he is going to buy. Obviously, as a collector, he won’t buy the same product twice.
Now, Iserlohn needs you to help him find the best solution of his problem, which means to maximize the total value of the products he can buy.
 

Input
Input contains multiple test cases. Each test case begins with three integers 1<=N<=100 representing the total number of products, 1 <= M<= 10000 the money Iserlohn gets, and 1<=K<=10 representing the sneaker brands. The following N lines each represents a product with three positive integers 1<=a<=k, b and c, 0<=b,c<100000, meaning the brand’s number it belongs, the labeled price, and the value of this product. Process to End Of File.
 

Output
For each test case, print an integer which is the maximum total value of the sneakers that Iserlohn purchases. Print "Impossible" if Iserlohn's demands can’t be satisfied.
 

Sample Input
  
  
5 10000 3 1 4 6 2 5 7 3 4 99 1 55 77 2 44 66
 

Sample Output
  
  
255


题目大意:给一些不同牌子的鞋子,要求用有限的钱去买鞋子。每种不同牌子的鞋子至少买一双,如果钱有的多,就可以继续买,但不必重复购买。

所以这个题目要求就是每组的鞋子至少买一双。

很容易想到是分组背包,但是又有所不同,分组背包是要求每组选一个,这里是至少选一个。

我刚开始想用分组背包把必选的选出来,但是发现后面比较难处理。同时可能在时间上也过不了。

这个题目后来参考了别人,利用一个dp[i][j]代表购买了前 i 种鞋子用掉  j 元。状态转移方程则有两个,一个是在上一组已经选好的情况下,在当前组里选一个;另一个是在当前组里面再选一个。

同时这题的初始化也有一定技巧。可以将所有的dp[i ][j ]赋为-1,代表在开始前所有的情况都不合法。但是要将dp[0][j]赋为0,这里可以理解为选0种的时候都是合法的。

#include<stdio.h>
#include<string.h>
struct node{
	int cost,val;
}p[15][10005];
int h[15],dp[15][10005];
int max(int a,int b)
{
	if(a>b)return a;
	else return b;
}
int main()
{
	int n,m,K,i,j,k,l,a,b,c;
	while(scanf("%d%d%d",&n,&m,&K)!=EOF)
	{
		memset(h,0,sizeof(h));
		for(i=1;i<=n;i++)
		{
			scanf("%d%d%d",&a,&b,&c);
			h[a]++;
			p[a][h[a]].cost=b;
			p[a][h[a]].val=c;
		}
		memset(dp,-1,sizeof(dp));
		for(i=0;i<=m;i++)
		dp[0][i]=0;
		for(i=1;i<=K;i++)       //种类
		for(k=1;k<=h[i];k++)      //每个种类里面有几个物品
		for(j=m;j>=p[i][k].cost;j--)
		{
			if(dp[i][j-p[i][k].cost]!=-1)               //对当前组里面选物品,不是第一次选
			dp[i][j]=max(dp[i][j],dp[i][j-p[i][k].cost]+p[i][k].val);
			if(dp[i-1][j-p[i][k].cost]!=-1)               //从前一组的状态里面,第一次选当前组的物品。
                       dp[i][j]=max(dp[i][j],dp[i-1][j-p[i][k].cost]+p[i][k].val);
		}
		if(dp[K][m]<0)printf("Impossible\n");
		else printf("%d\n",dp[K][m]);
	}
	return 0;
}

最后判断是否impossible:对于这么一个状态dp[ i ][ ],如果所有的dp[ i ] [ ]都为-1,表示第i类物品一个都没有被选,那样的话,i后面种类的物品都不必选了,因为第i种一件都不能被选到。已经不满足每组至少选一个的条件了。

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值